﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Xml;

namespace XmlProtocolSampleApp
{
    public partial class BaxiProperties : Form
    {

        private XmlProtocolController _ctrl;

        public Dictionary<string, string> Properties { get; set; }

        public BaxiProperties(XmlProtocolController ctrl, Dictionary<string, string> values)
        {
            _ctrl = ctrl;
            Properties = values;
            InitializeComponent();
            SetPropertiesOnWindow();
        }

        private void SetPropertiesOnWindow()
        {
            foreach (var item in Properties)
            {
                var ctrl = this.Controls.Find("txt" + item.Key, true);

                if (ctrl != null && ctrl.Count() > 0)
                {
                    ctrl[0].Text = item.Value;
                }
            }
        }

        private void btnClose_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void btnSave_Click(object sender, EventArgs e)
        {
            var changedValues = new Dictionary<string, string>();
            foreach (var item in Properties)
            {
                var ctrl = this.Controls.Find("txt" + item.Key, true);
                if (ctrl != null && ctrl[0].Text != item.Value)
                {
                    changedValues.Add(item.Key, ctrl[0].Text);
                }
            }
            if (changedValues.Any())
            {
                _ctrl.SetBaxiProperties(changedValues);

                foreach (var changed in changedValues)
                {
                    Properties[changed.Key] = changed.Value;
                }

            }

            this.Close();
        }
    }
}
