﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace XmlProtocolSampleApp
{

    /// <summary>
    /// A custom Form for displaying a confirmation dialog to POS operator when BAXI is
    /// requesting it (bypassing PIN code etc.)
    /// </summary>
    public partial class ConfirmationDialog : Form
    {

        private string infoText;
        private int messageType;
        private int dialogTimeOut;

        public string InfoText { get { return this.infoText; } }
        public int MessageType { get { return this.messageType; } }

        public ConfirmationDialog(int messageType, string infoText, int dialogTimeOut = 0)
        {
            this.infoText = infoText;
            this.messageType = messageType;
            this.dialogTimeOut = dialogTimeOut;
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.AcceptButton = btnYes;
            this.CancelButton = btnNo;

            this.DialogText.Text = infoText;

            // For handling terminal reboot situations where confirmation dialog is 
            // left hanging for nothing. 
            Timer dialogTimeOutTimer = new Timer();
            dialogTimeOutTimer.Interval = 60000; // 60 secs
            dialogTimeOutTimer.Tick += new EventHandler(dialogTimeOutTimer_Tick);
            dialogTimeOutTimer.Start();

        }

        private void dialogTimeOutTimer_Tick(object sender, EventArgs e)
        {
            if (InvokeRequired)
            {
                Invoke(new Action(() => this.Dispose()));
            }
            else
            {
                this.Dispose();
            }
        }


        public void AddButtonClickListener(EventHandler listener)
        {
            this.btnYes.Click += listener;
            this.btnNo.Click += listener;
        }

    }
}